================================
SLASH/ Installation Instructions
================================

.. role:: ref(emphasis)

Installing from Source
======================

.. _Compiling Varnish from source: https://varnish-cache.org/docs/trunk/installation/install_source.html

generic
-------

* Compile and install varnish-cache 7.2.0 or later by the
  `Compiling Varnish from source`_ documentation.

  Note in particular the ``autoconf-archive`` requirement.

* Optionally, install the following additional prerequisites:

recommendations for optimal fellow storage performance
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

.. _liburing: https://github.com/axboe/liburing.git
.. _xxhash: https://github.com/Cyan4973/xxHash

* On Linux, it is strongly recommended to add io_uring support by
  installing kernel >= 5.10 (better: >= 5.13) and `liburing`_.

* For optimal performance, it is recommended to install `xxhash`_ and
  later use ``xxh3_64`` or ``xxh3_128`` by setting the ``hash_obj``
  and ``hash_log`` tuneables.

  Note that a fellow storage using any of the `xxhash`_ hashes can
  only be loaded by an instance with `xxhash`_ support compiled in.

* On big systems with many CPUs, ``lru_exponent`` can be tuned to
  achieve maximum performance with hundreds of thousands of requests per
  second.

  Reasonable values are yet to be determined experimentally.

compiling
~~~~~~~~~

* set and export the ``VARNISHSRC`` environment variable to point to
  the varnish-cache source tree

* In the ``slash`` source tree, run::

    ./bootstrap
    make check
    make install

The last step will probably need to be run as root (e.g. using ``sudo``).

When installation has succeeded, continue with the `Next Steps`_.

Debian/Ubuntu
-------------

This guide was written based on:

* Debian 11 base install
* Varnish-Cache binary packages

Add the packagecloud repository, if not already done::

  sudo apt-get install curl
  curl -sO \
  https://packagecloud.io/install/repositories/varnishcache/varnish72/script.deb.sh
  # REVIEW script.deb.sh and continue only if considered safe
  sudo bash script.deb.sh

Install varnish-cache dev package and other required packages::

  sudo apt-get install -y \
    varnish-dev \
    git \
    autoconf \
    autoconf-archive \
    automake \
    libtool \
    gcc \
    python3-docutils \
    python3-sphinx \
    libpcre2-dev \
    libreadline-dev \
    liburing-dev \
    libxxhash-dev \
    libncurses-dev

Download and extract the varnish-cache source code for the installed
version, and export the ``VARNISHSRC`` environment variable to the right
directory::

  v=$(/usr/sbin/varnishd -V 2>&1 | grep -Eo 'varnish-[0-9.]+')
  curl -LO \
    https://github.com/varnishcache/varnish-cache/archive/refs/tags/${v}.tar.gz
  tar xf ${v}.tar.gz
  VARNISHSRC=$(realpath varnish-cache-${v})
  export VARNISHSRC

Build required components from varnish-cache::

  ( pushd $VARNISHSRC && \
    ./autogen.des && \
    pushd include && \
    make vcs_version.h && \
    popd && pushd lib/libvsc &&
    make \
    )

Clone this repository::

  git clone http://code.uplex.de/uplex-varnish/slash.git

Enter the ``slash`` directory and call ``bootstrap``::

  cd slash
  ./bootstrap

A summary similar to the one shown below should be output. In
particular, ``xxhash: yes`` and ``uring: yes`` should be contained::

	==== slash 0.9 ====

	varnish:      7.2.1
	prefix:       /usr
	vmoddir:      /usr/lib/varnish/vmods
	vcldir:       ${datarootdir}/varnish/vcl
	pkgvcldir:    ${vcldir}/${PACKAGE}

	compiler:     gcc
	cflags:       -g -O2 -fstack-protector-all
	ldflags:

	xxhash:       yes
	uring:        yes
	aio:          no

Build, test and install SLASH/::

  make check && sudo make install

Configuration options
---------------------

.. _autoconf: https://www.gnu.org/software/autoconf/

Among other things, ``bootstrap`` invokes the ``configure`` script
generated by `autoconf`_, and any command-line options given with
``bootstrap`` are passed on to ``configure``. For example,
``VARNISHSRC`` can be specified like this (since ``bootstrap`` is the
only step that requires it)::

  bootstrap VARNISHSRC=/path/to/varnish-cache

CLI options can also be used, for example, to set ``CFLAGS``, select
the C compiler (with ``CC``), or specify the installation prefix.
``bootstrap --help`` (which invokes ``configure --help``) shows all of
the relevant variables and available options.

For most installations, the default values (with no CLI options, as
shown above) are sufficient.

Container environments
-----------------------------
Depending on your container environment it might be necessary to enable elevated privileges for your container, in order to fully support ``io_uring`` (liburing).

The reason for this is that unfortunetally, support in the default moby seccomp profile for ``io_uring`` has been dropped which is used by docker. `seccomp: block io\_uring\_* syscalls in default profile
<https://github.com/moby/moby/commit/891241e7e74d4aae6de5f6125574eb994f25e169/>`_.

Note that there is a good reasoning for this. So before applying the suggested solutions below, you should do your own research about the risks.

To build and run the tests for fellow with liburing support in the image build process, you will need elevated privileges for the build context. In docker, simply create an ``insecure-builder`` with the command ``docker buildx create --use --name insecure-builder --buildkitd-flags '--allow-insecure-entitlement security.insecure'``
See `Allow extra privileged entitlement (--allow)
<https://docs.docker.com/engine/reference/commandline/buildx_build/#allow>`_.

In order to build the image just run:
``docker buildx build . -t varnish:7.4.2-slash --allow security.insecure --load``

Also docker compose_ (version >2.15.0) supports a privileged build context.

.. _compose: https://docs.docker.com/compose/compose-file/build/#privileged

Support for liburing in the runtime environment however, will work out-of-the box with ``privileged: true`` directive.
However, in order to create a setup with the principle of least privilege, you will need to create your own ``seccomp`` profile.

For this download a copy of the seccomp_ (moby v25.0.2) profile

.. _seccomp: https://raw.githubusercontent.com/moby/moby/v25.0.2/profiles/seccomp/default.json

Add the following syscall rule block::

  {
    "names": [
            "io_uring_enter",
            "io_uring_register",
            "io_uring_setup"
    ],
    "action": "SCMP_ACT_ALLOW"
  }

You can now load this profile in docker using the ``security-opt`` option, in order to strictly allow io\_uring syscalls in addition.

Next Steps After Installation
-----------------------------

.. _Next Steps:

Varnish working directory space requirements
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Ensure that the varnish working directory as specified by the ``-n``
argument to ``varnishd`` has sufficient space to hold *buddy* and
*fellow* metadata (bitmaps). It defaults to ``/var/run/varnish``, but
is often changed by packagers to ``/var/lib/varnish``.

As a rule of thumb with rounded up numbers, the amount of space needed
in the working directory is roughly:

-   5 MB for each GB of memory cache
-  65 MB for each TB of disk cache

*Note* that this is **megabytes** for gigabytes of memory and terabytes of
disk.

Continue Reading
~~~~~~~~~~~~~~~~

Now you should be ready to go.

Consult the :ref:`vmod_slash(3)` and :ref:`slashmap(1)` man pages for
detailed information on how to configure, use and monitor the SLASH/
storage engines.

The remainder of this document contains system tuning recommendations.

System Setup for Optimal Performance
====================================

buddy & fellow memory cache
---------------------------

For the time being, these recommendations only apply to Linux.

The `buddy` allocator, which is also used by the memory cache of
`fellow`, will, by default, attempt to allocate memory from huge pages
and try to lock pages in RAM and thus prevent paging.

huge pages
~~~~~~~~~~

To the best of our knowledge, best performance is thus achieved by
ensuring that the system has sufficient huge pages reserved by

* either using the kernel command line, for example by adding to
  ``/etc/default/grub``::

    GRUB_CMDLINE_LINUX="hugepagesz=1GB hugepages=300"

  to configure 300GB of 1GB huge pages at boot and rebooting

* or by applying the same configuration at runtime through::

    echo 300 \
    >/sys/kernel/mm/hugepages/hugepages-1048576kB/nr_hugepages

  to, again, configure 300GB of 1GB huge pages.

The 300GB used in these examples have to be adjusted approriately to
the desired memory cache size.

Alternatively, 2MB huge pages can be used where 1GB pages are not
available.

transparent huge pages
~~~~~~~~~~~~~~~~~~~~~~

The hupe pages setting referred to above concerns SLASH/ itself, so from the
perspective of ``varnishd``, it "only" concerns the storage engine.

.. _#4147: https://github.com/varnishcache/varnish-cache/pull/4174

Since the merge of `#4147`_ (post 7.6.1), Varnish-Cache gained a
``transparent_hugepage`` setting of the ``linux`` jail, which defaults to
``try-disable``. This setting does *not* affect SLASH/ preferring huge page
mappings, if available.

Yet the main benefit of disabling huge pages presumably only affects the
``malloc`` storage engine, which SLASH/ has been designed to replace. So we
suspect that *enabling* THP for the remaining memory allocations of ``varnishd``
is advantageous when used with SLASH/. The following ``varnishd`` command line
argument enables it::

        -j linux,transparent_hugepage=enable

Feedback on real world experience with this recommendation is highly welcome!

locked memory
~~~~~~~~~~~~~

:ref:`varnishd(1)` should be started with a limit on locked memory
higher than the configured memory size. We recommend to configure no
limit on locked memory by calling::

  ulimit -l unlimited

or using::

  LimitMEMLOCK=infinity

with :ref:`systemd(1)`, or whatever appropriate method to lift the
limit on locked memory.

fellow storage
--------------

`fellow` uses its own memory caching strategy, so double caching by
the operating system should be avoided. `fellow` thus tries to open
the storage path with ``O_DIRECT``, where available.

Nonetheless, to the best of our knowledge, avoiding the file system
overhead results in optimal performance. Where possible, the `fellow`
*path* should therefore point to a disk storage device. Using a mirror
or mirror/stripe (RAID1 or RAID10) is recommended for optimal
resilience.

As the IO pattern of `fellow` usually is highly random and because
access times are crucial for overall latency, using storage with the
lowest possible access times for random access is highly
recommended. Flash based storage (SSD, NVMe) usually falls into this
category.
